#+++
#  RCS $Id: upd-bind.awk,v 14.26 1992/08/26 23:57:14 tom Exp tom $
#  title:	upd-bind.awk
#  abstract:	Update key bindings in JOVE manual.	
#  author:	T.R.Hageman, Groningen, The Netherlands.
#  created:	november 1991 (extracted from tex-bind.sh)
#  modified:	(see RCS Log at end)
#  description:
#	Used in "make -f make-tex update-bind"
#---

FILENAME != File {

	File = FILENAME
	if (Nfile++ == 1) {
		# first file contains binding descriptions
		for (i in binding) {
			# find unbound functions
			if (binding[i] == "")
				binding[i] = "Not Bound"
		}
		# Whether to say it when a feature is not available.
		# (this is purposely NOT in BEGIN so it can be changed from the
		#  command line)
		if (notavail == "" || notavail != 0) {
			notavail = "Not Available"
			sepnotavail = " - " notavail
		}
		else {
			notavail = "Not Bound"
			sepnotavail = ""
		}
	}
}

Nfile == 1 {

	#collect bindings from first file

	name = $NF

	if (binding[name] == "")
		sep = ""
	else
		sep = ", "
	for (i = 1;  i < NF;  sep = " ")
		binding[name] = binding[name] sep $i++

	if (debug > 0)
		printf "%-32s %s\n", name, binding[name]

	next
}

# Find the `define-command' lines in the JOVE manual,
# 	(preprocessed) TeX:	|\dc <entry-name> <binding>|
# 	nroff:			|.dc "<entry-name>" "<binding>"|
#	(both need some postprocessing.)
# some entries pass as-is

/^[\\.]dc/ && $2 !~ /"?(shell|self-insert|accent)"?/ {

	# catch unavailable features

	if (binding[$2] == "") {
		if ($3 ~ /"?\(?variable.*/)
			binding[$2] = "(variable)" sepnotavail
		else
			binding[$2] = notavail
	}

	# fill in binding in section header
	print $1, $2, binding[$2]
	next
}

debug == "" {
	print
}

END {
	if (Nfile == 1)
		for (i in binding)
			printf "%-32s %s\n", i, binding[i]
}

#=======================================================================
# $Log: upd-bind.awk,v $
# Revision 14.26  1992/08/26  23:57:14  tom
# add RCS directives.
#
#=======================================================================
